#include <minigui.ch>

function Acct()
	private lAddmode := .f., lEditmode := .f., aDbf := {}
	
	if isWindowDefined(frmAcct)
      return nil
   endif
	
	netselect("acct")
	set order to tag acctnm
	go top
	
	load window frmAcct
	center window frmAcct
	activate window frmAcct
	return nil
	
	
Static Function RefreshData()
	local lEditable := (lAddmode .or. lEditmode), lGetData 
	
	netselect("acct")
	lGetData := !(lAddmode .or. acct->(eof()))
	
	frmAcct.txtAcctcd.readonly := !lAddMode
	frmAcct.txtAcctnm.readonly := !lEditable
	frmAcct.txtActype.readonly := !lEditable
	frmAcct.chkContra.enabled := lEditable
	frmAcct.chkIsTrad.enabled := lEditable
	frmAcct.chkIsTax.enabled := lEditable
	frmAcct.chkSubLed.enabled := lEditable
	frmAcct.txtOpgbal.readonly := !lEditable
	
	frmAcct.cmdFirst.enabled := !lEditable
	frmAcct.cmdPrev.enabled := !lEditable
	frmAcct.cmdNext.enabled := !lEditable
	frmAcct.cmdLast.enabled := !lEditable
	frmAcct.cmdAdd.enabled := !lEditable
	frmAcct.cmdModify.enabled := !lEditable
	frmAcct.cmdDelete.enabled := !lEditable
	frmAcct.cmdSave.enabled := lEditable
	frmAcct.cmdCancel.enabled := lEditable
	frmAcct.cmdFind.enabled := !lEditable
	
	frmAcct.txtAcctcd.value := if(lGetData, acct->acctcd, '')
	frmAcct.txtAcctnm.value := if(lGetData, acct->acctnm, '')
	frmAcct.txtActype.value := if(lGetData, acct->actype, '')
	frmAcct.chkContra.value := if(lGetData, acct->contra, .f.)
	frmAcct.chkIsTrad.value := if(lGetData, acct->istrad, .f.)
	frmAcct.chkIsTax.value := if(lGetData, acct->istax, .f.)
	frmAcct.chkSubLed.value := if(lGetData, acct->subled, .f.)
	frmAcct.txtOpgbal.value := if(lGetData, acct->opgbal, 0.00)
	
	return nil
	
	
Static function WinLostFocus()
	netselect("acct")
	aDbf := savedbf()
	return nil
	

Static function WinGotFocus()
	if len(aDbf) > 0
		restdbf(aDbf)
	endif
	return nil	
	

Static function GoFirst()
	netselect("acct")
	go top
	RefreshData()
	return nil
	
	
Static function GoPrev()
	netselect("acct")
	if !bof()
		skip -1
	endif
	if bof()
		go top
	endif
	RefreshData()
	return nil
	
	
Static function GoNext()
	netselect("acct")
	if !eof()
		skip
	endif
	if eof()
		go bottom
	endif
	RefreshData()
	Return nil
	
	
Static function GoLast()
	netselect("acct")
	go bottom
	RefreshData()
	Return nil
	

Static function AddRec()
	lAddMode := .t.
	RefreshData()
	frmAcct.txtAcctcd.setfocus()
	return nil


Static function ModifyRec()
	netselect("Acct")
	if bof() .or. eof()
		return nil
	endif
	if !Rlock()
		msginfo("Another user is editing this record!")
		return nil
	endif
	lEditMode := .t.
	RefreshData()
	frmAcct.txtAcctnm.setfocus()
	return nil
	
	
Static function DeleteRec()
	netselect("Acct")
	if bof() .or. eof()
		return nil
	endif
	if splac
		msginfo("Cannot delte: special account!")
		return nil
	endif
	if !Rlock()
		msginfo("Another user is editing this record!")
		return nil
	endif
	if msgyesno("Do you really want to delete this record") 
		delete
		unlock
		//commit
		frmAcct.cmdNext.action()
	endif
	return nil
	
	
Static function SaveRec()
	local mAcctcd, mAcctnm, mActype, mContra, mIsTax, mSubled, mOpgbal, mErrormsg := "", mOldrec
	
	mAcctcd := frmAcct.txtAcctcd.value
	mAcctnm := frmAcct.txtAcctnm.value
	mActype := frmAcct.txtActype.value
	mContra := frmAcct.chkcontra.value
	mIstax := frmAcct.chkIsTax.value
	mSubled := frmAcct.chkSubled.value
	mOpgbal := frmAcct.txtOpgbal.value
	
	if empty(mAcctcd)
		mErrormsg += if(empty(mErrormsg), "", CRLF)+"Please enter account code"
	endif
	
	if empty(mAcctnm)
		mErrormsg += if(empty(mErrormsg), "", CRLF)+"Please enter account name"
	endif
	
	if empty(mActype) .or. !(mActype $ "ALIE")
		mErrormsg += if(empty(mErrormsg), "", CRLF)+"Please enter valid account type"
	endif
	
	if mContra .and. mSubled
		mErrormsg += if(empty(mErrormsg), "", CRLF)+"Contra account cannot have sub account"
	endif
	
	netselect("acct")
	mOldrec := iif(eof(), 0, recno())
	
	if lAddmode
		locate for acctcd = mAcctcd
		if found()
			mErrormsg += if(empty(mErrormsg), "", CRLF)+"Duplicate account code"
		endif
	endif
	
	locate for upper(acctnm) = upper(mAcctnm)
	if found() .and. recno() != mOldRec
		mErrormsg += if(empty(mErrormsg), "", CRLF)+"Duplicate account name"
	endif
	
	if mOldrec <> 0
		go (mOldrec)
	endif

	if !empty(mErrormsg)
		msginfo(mErrormsg)
		return nil
	endif
	
	if lAddMode
		append blank
	endif
	replace acctcd with mAcctcd
	replace acctnm with mAcctnm
	replace actype with mActype
	replace contra with mContra
	replace istax with mIstax
	replace subled with mSubled
	replace opgbal with mOpgbal
	//commit
	unlock
	
	lAddmode := .f.
	lEditmode := .f.
	RefreshData()
	
	return nil
	
	
Static function CancelRec()
	lAddmode := .f.
	lEditmode := .f.
	netselect("acct")
	unlock
	RefreshData()
	return nil	

	
Static Function FindRec()
	local mRecno, aAcctnm := {}, i :=0
	netselect("ACCT")
	set order to 2
	mRecno = iif(eof(), 0, recno())
	go top
	dbeval({|| aadd(aAcctnm, acct->acctnm)})
	
	if recno() <> 0
		go (mRecno)
	endif
	
	i := frmFind(aAcctnm)
	
	if i > 0
		netselect("acct")
		set order to tag acctnm
		seek upper(aAcctNm[i])
		RefreshData()
	endif
	
	return nil
	

	
	
Function FrmFind(aData)
private aTempData := {}, mPtr := 0

	aeval(aData, {|x| aadd(aTempData, x)})
	
	WinFrmFind()
	frmFind.Center
	frmFind.Activate
	Return (mPtr)


Static function InitFind()
	frmFind.lstFind.deleteallitems()
	aeval(aTempData, {|x| frmFind.lstFind.additem(x)})
	frmFind.lstFind.setfocus()
	return nil
			
	
	
Function WinfrmFind()	
	
DEFINE WINDOW AT 140 , 235 ;
	WIDTH 550 HEIGHT 394 ;
	TITLE "Find"
	MODAL ;
	ON INIT InitFind()

    DEFINE BUTTON cmdOk
           ROW    330
           COL    120
           WIDTH  100
           HEIGHT 28
           ACTION {mPtr := frmFind.lstFind.value, frmFind.release()}
           CAPTION "&Ok"
           FONTNAME  "Arial"
           FONTSIZE 9
           TOOLTIP  ""
           FONTBOLD .T.
           FONTITALIC .F.
           FONTUNDERLINE .F.
           FONTSTRIKEOUT .F.
           ONGOTFOCUS NIL
           ONLOSTFOCUS NIL
           HELPID NIL
           FLAT .F.
           TABSTOP .T.
           VISIBLE .T.
           TRANSPARENT .F.
           MULTILINE .F.
     END BUTTON  

    DEFINE BUTTON cmdCancel
           ROW    330
           COL    300
           WIDTH  100
           HEIGHT 28
           ACTION {mPtr = 0, frmFind.release()}
           CAPTION "&Cancel"
           FONTNAME  "Arial"
           FONTSIZE 9
           TOOLTIP  ""
           FONTBOLD .T.
           FONTITALIC .F.
           FONTUNDERLINE .F.
           FONTSTRIKEOUT .F.
           ONGOTFOCUS NIL
           ONLOSTFOCUS NIL
           HELPID NIL
           FLAT .F.
           TABSTOP .T.
           VISIBLE .T.
           TRANSPARENT .F.
           MULTILINE .F.
     END BUTTON  

     DEFINE LISTBOX lstFind
            ROW    0
            COL    0
            WIDTH  541
            HEIGHT 323
            ITEMS {""}
            VALUE 0
            FONTNAME "Lucida Console"
            FONTSIZE 10
            TOOLTIP ""
            ONCHANGE NIL
            ONGOTFOCUS NIL
            ONLOSTFOCUS NIL
            FONTBOLD .F.
            FONTITALIC .F.
            FONTUNDERLINE .F.
            FONTSTRIKEOUT .F.
            BACKCOLOR {253,254,199}
            FONTCOLOR NIL
            ONDBLCLICK {frmFind.cmdOk.action()}
            HELPID NIL
            TABSTOP .T.
            VISIBLE .T.
            SORT .F.
            MULTISELECT .F.
            DRAGITEMS .F.
     END LISTBOX  

END WINDOW	
return nil